//=============================================================================
// Vertex.h by Frank Luna (C) 2005 All Rights Reserved.
//
// This file contains all of our vertex structures.  We will add to it
// as needed throughout the book.
//=============================================================================

#ifndef VERTEX_H
#define VERTEX_H

#include <d3dx9.h>


// Call in constructor and destructor, respectively, of derived application class.
void InitAllVertexDeclarations();
void DestroyAllVertexDeclarations();


//===============================================================
/*struct VertexPos
{
	VertexPos():pos(0.0f, 0.0f, 0.0f){}
	VertexPos(float x, float y, float z):pos(x,y,z){}
	VertexPos(float xyz[3]) : pos(xyz[0], xyz[1], xyz[2]) {}
	VertexPos(const D3DXVECTOR3& v):pos(v){}

	D3DXVECTOR3 pos;
	static IDirect3DVertexDeclaration9* Decl;
};*/

//===============================================================
/*struct VertexCol
{
	VertexCol():pos(0.0f, 0.0f, 0.0f),col(0x00000000){}
	VertexCol(float x, float y, float z, D3DCOLOR c):pos(x,y,z), col(c){}
	VertexCol(float xyz[3], D3DCOLOR c) : pos(xyz[0], xyz[1], xyz[2]), col(c) {}
	VertexCol(const D3DXVECTOR3& v, D3DCOLOR c):pos(v),col(c){}

	D3DXVECTOR3 pos;
	D3DCOLOR    col;
	static IDirect3DVertexDeclaration9* Decl;
};*/

//===============================================================
/*
struct VertexPN
{
	VertexPN()
		:pos(0.0f, 0.0f, 0.0f),
		normal(0.0f, 0.0f, 0.0f){}
	VertexPN(float x, float y, float z, 
		float nx, float ny, float nz):pos(x,y,z), normal(nx,ny,nz){}
	VertexPN(const D3DXVECTOR3& v, const D3DXVECTOR3& n)
		:pos(v),normal(n){}

	D3DXVECTOR3 pos;
	D3DXVECTOR3 normal;
	static IDirect3DVertexDeclaration9* Decl;
};*/

struct VertexPos
{
	float x, y, z;
	static IDirect3DVertexDeclaration9* Decl;
};
struct VertexCol
{
	float x, y, z;
	D3DCOLOR    col;
	static IDirect3DVertexDeclaration9* Decl;
};
struct VertexPN
{
	float x, y, z;
	float nx, ny, nz;
	VertexPN(float _x, float _y, float _z, float _nx, float _ny, float _nz): x(_x), y(_y), z(_z), nx(_nx), ny(_ny), nz(_nz){}

	static IDirect3DVertexDeclaration9* Decl;
};

#endif // VERTEX_H